#include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct L *Lref; //:    .
typedef struct T *Tref; //:    .

//   .
typedef struct L 
{ int Key; //  .
  int Count; // .
  Tref Trail; //   .
  Lref Next; //       .
} Leader;

typedef struct T //   .
{ 
  int Id; 
  Tref Next; 
} Trailer;

class Spisok
{
  private:
    Lref Head; //     .
    Lref Tail; //   
               //     .
    void SearchGraph (int, Lref *);
    void Search (int, Lref *);
  public:
    Spisok () {//   .
               Head = Tail  = new (Leader); }
    void MakeGraph ();
    void AddGraph (int, int);
    void DeleteGraph (int, int);
    void PrintGraph ();
    void DeleteY (int);
};

void main ()
{
  Spisok A;
  int x,y; //   
  //     .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //   .
  cout<<"    ...\n";
  cout<<"  : "; cin>>x;
  cout<<"  : "; cin>>y;
  A.AddGraph (x,y);
  A.PrintGraph (); cout<<endl;
  //   .
  cout<<"    ...\n";
  cout<<"  : "; cin>>x;
  cout<<"  : "; cin>>y;
  A.DeleteGraph (x,y);
  A.PrintGraph (); cout<<endl;
  //  .
  cout<< "  : "; cin>>y;
  A.DeleteY (y);
  A.PrintGraph (); cout<<endl;
} 

void Spisok::Search (int w, Lref *h)
//   *h     
// w.   ,    NULL .
{
  *h = Head;
  (*Tail).Key = w; // " ".
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail) //        w.
  *h = NULL;
} 

void Spisok::SearchGraph (int w,Lref *h)
//   *h     
//  w.    ,   
//  .
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     *Head.
  { Tail = new (Leader); (**h).Count = 0; 
    (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head   
// ,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; //  .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
   cout<<"   : "; cin>>y;
   //,      (x,y)?
   SearchGraph (x,&p); SearchGraph (y,&q);
   r = (*p).Trail; Res = FALSE; 
   while ((r!=NULL)&&(!Res)) 
    if ((*r).Id==y) Res = TRUE; 
    else r = (*r).Next; 
   if (!Res) //  ,     .
   { t = new (Trailer); (*t).Id = y; 
     (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; } 
     cout<<"   : "; cin>>x;
   }
}

void Spisok::AddGraph (int x,int y)
//  (x,y) (   !)   
//,    Head.
{
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //     .
  //,      (x,y)? 
  SearchGraph (x,&p);
  SearchGraph (y,&q);
  r = (*p).Trail; Res = FALSE;
  while ((r!=NULL)&&(!Res)) 
  if ((*r).Id==y) Res = TRUE; else r = (*r).Next;
  if (!Res)
  { //  ,     .
    t = new (Trailer); (*t).Id = y; (*t).Next = (*p).Trail; 
    (*p).Trail = t; (*q).Count++;
  }
} 

void Spisok::DeleteGraph (int x,int y)
//   Head   
//,   
//    (x,y).
{
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //     .
  //,      (x,y)?
  Search (x, &p); Search (y, &q);
  if ((p!=NULL)&&(q!=NULL))
  { // x  y   .
    r = (*p).Trail; Res = FALSE; 
    while ((r!=NULL)&&(!Res)) 
      if ((*r).Id==y) Res = TRUE; 
      else r = (*r).Next; 
    if (Res) //  ,   .
      if (r==(*p).Trail)
        { (*p).Trail = (*(*p).Trail).Next; delete r; (*q).Count--; } 
      else 
      {
         t = (*p).Trail; 
         while ((*t).Next!=r) t = (*t).Next;
         (*t).Next = (*(*t).Next).Next; delete r; (*q).Count--; }
  }
} 

void Spisok::PrintGraph ()
//  ,   
//Head    .
{
  Lref p; // .
  Tref q; // .
  p = Head;
  while (p!=Tail)
  {
    cout<<"("<<(*p).Key; q = (*p).Trail; 
    while (q!=NULL) 
    { cout<<(*q).Id; q = (*q).Next; } 
      cout<<")"; p = (*p).Next; cout<<" ";
    }
}

void Spisok::DeleteY (int y)
//   Head   - 
//,      y.
{ 
  Lref p,q; // .
  Tref r,s; // .
  int x; // .
  //   (x,y),     y.
  p = Head; 
  while (p!=Tail) 
  { x = (*p).Key; DeleteGraph (x,y); p = (*p).Next; } 
  //    y.
  SearchGraph (y, &p); r = (*p).Trail;
  while (r!=NULL) 
  { s = r; r = (*r).Next; delete s; } 
  // ,   y,     .
  q = Head; 
  if (q==p) { Head = (*Head).Next; delete q; } 
  else { 
     while ((*q).Next!=p) q = (*q).Next; 
     (*q).Next = (*p).Next; delete p; }
} 
